/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/

package at.jku.ssw.ftcm;

import org.eclipse.jface.text.source.AnnotationPainter;
import org.eclipse.ui.texteditor.AbstractDecoratedTextEditor;
import org.eclipse.ui.texteditor.ITextEditor;
import org.eclipse.ui.texteditor.SourceViewerDecorationSupport;

import java.lang.reflect.Field;

/**
 * Implementing helper functions which are not provided via API till now.
 *
 * @author David Pfeffer
 */
public class EclipseHacks {

    /**
     * Uses reflection to get the AnnotationPainter from a decorated text
     * editor.
     *
     * @param part
     * @return
     */
    public static AnnotationPainter getAnnotationPainter(ITextEditor part) {

        try {
            Field fSourceViewerDecorationSupport = AbstractDecoratedTextEditor.class.getDeclaredField("fSourceViewerDecorationSupport");
            fSourceViewerDecorationSupport.setAccessible(true);

            SourceViewerDecorationSupport s = (SourceViewerDecorationSupport) fSourceViewerDecorationSupport.get(part);

            Field fAnnotationPainter = s.getClass().getDeclaredField("fAnnotationPainter");
            fAnnotationPainter.setAccessible(true);

            return (AnnotationPainter) fAnnotationPainter.get(s);
        } catch (SecurityException e) {
            e.printStackTrace();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (NoSuchFieldException e) {
            e.printStackTrace();
        }

        return null;
    }
}
