/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/

package at.jku.ssw.ftcm.export;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class ClassFeature extends GenericFeatureImpl implements GenericFeature {

    private String name;
    private List<MethodFeature> methodFeatures;

    public ClassFeature(String name) {
        super();
        this.name = name;
        this.methodFeatures = new ArrayList<>();
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void addMethodFeature(MethodFeature mf) {
        methodFeatures.add(mf);
    }

    public List<MethodFeature> getMethodFeatures() {
        return Collections.unmodifiableList(methodFeatures);
    }

}
