package at.jku.mevss.anttracks.diff;

import at.jku.mevss.anttracks.classification.ClassifierChain;
import at.jku.mevss.anttracks.classification.ConditionalClassifierList;
import at.jku.mevss.anttracks.classification.Filter;
import at.jku.mevss.anttracks.classification.nodes.GroupingNode;
import at.jku.mevss.anttracks.heap.DetailedHeap;

import javax.naming.OperationNotSupportedException;
import java.io.DataOutputStream;
import java.util.List;
import java.util.stream.LongStream;

public interface AddressCollection extends GroupingNode.GroupingDataCollection {

    void writeToMetaData(DataOutputStream dos) throws OperationNotSupportedException;

    public interface AddressCollectionIterator {
        boolean hasNext();

        long next();
    }

    AddressCollectionIterator getIterator();

    void put(long address);

    boolean contains(long address);

    AddressCollection sort();

    boolean isSorted();

    LongStream stream();

    AddressCollection unionWith(AddressCollection other);

    AddressCollection unionWith(AddressCollection[] other);

    AddressCollection intersectWith(AddressCollection other);

    AddressCollection without(AddressCollection other);

    AddressCollection without(AddressCollection[] other);

    AddressCollection cloneAndIntersectWith(AddressCollection other);

    AddressCollection cloneWithout(AddressCollection other);

    AddressCollection clone();

    void setLastHeap(DetailedHeap lastHeap);

    GroupingNode classify(ClassifierChain classifier, ConditionalClassifierList conditionalClassifier, List<Filter> filters);
}
