/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.heap;

import java.util.HashMap;
import java.util.Map;
import java.util.stream.Stream;

public class GarbageCollectionCauses {

    private final Map<Integer, GarbageCollectionCause> causes;

    public GarbageCollectionCauses() {
        causes = new HashMap<>();
    }

    public void add(int id, String cause, boolean ok) {
        causes.put(id, new GarbageCollectionCause(id, cause, ok));
    }

    public GarbageCollectionCause get(int id) {
        return causes.get(id);
    }

    public GarbageCollectionCause[] getAll() {
        return causes.values().stream().toArray(GarbageCollectionCause[]::new);
    }

    public GarbageCollectionCause getByName(String name) {
        return Stream.of(getAll()).filter(x -> x.name.equals(name)).findFirst().orElse(null);
    }

}
