package at.jku.mevss.anttracks.heap.datastructures;

import at.jku.mevss.anttracks.heap.symbols.AllocatedType;

import java.util.Arrays;

public class DataStructureDefinition {
    public final AllocatedType type;
    public final AllocatedType[] followTypes;
    public final AllocatedType[] flatTypes;
    public final boolean isHead;

    public DataStructureDefinition(AllocatedType type) {
        this.type = type;
        this.followTypes = new AllocatedType[0];
        this.flatTypes = new AllocatedType[0];
        this.isHead = false;
    }

    public DataStructureDefinition(AllocatedType type, AllocatedType[] followTypes, AllocatedType[] flatTypes, boolean isHead) {
        this.type = type;
        this.followTypes = followTypes;
        this.flatTypes = flatTypes;
        this.isHead = isHead;
    }

    public boolean hasFollower(AllocatedType follower) {
        return Arrays.stream(followTypes).anyMatch(followType -> follower.isAssignableTo(followType));
    }

    public boolean containsFlat(AllocatedType flatty) {
        return Arrays.stream(followTypes).anyMatch(flatType -> flatty.isAssignableTo(flatType));
    }
}
