package at.jku.mevss.anttracks.heap.iteration;

import at.jku.mevss.anttracks.classification.ClassifierChain;
import at.jku.mevss.anttracks.classification.ConditionalClassifierList;
import at.jku.mevss.anttracks.classification.nodes.MapGroupingNode;
import at.jku.mevss.anttracks.heap.ObjectVisitor;
import at.jku.mevss.anttracks.heap.objects.ObjectInfo;
import at.jku.mevss.anttracks.heap.roots.RootPtr;
import at.jku.mevss.anttracks.heap.space.SpaceInfo;
import at.jku.mevss.anttracks.heap.symbols.AllocatedType;
import at.jku.mevss.anttracks.heap.symbols.AllocationSite;
import at.jku.mevss.anttracks.parser.EventType;

import java.util.List;

class ThreadLocalHeapObjectMapGroupingVisitor extends MapGroupingNode implements ObjectVisitor {
    private final ClassifierChain classifier;
    private final ConditionalClassifierList conditionalClassifier;

    public ThreadLocalHeapObjectMapGroupingVisitor(ClassifierChain classifier, ConditionalClassifierList conditionalClassifier) {
        this.classifier = classifier;
        this.conditionalClassifier = conditionalClassifier;
    }

    @Override
    public void visit(long address,
                      ObjectInfo objectInfo,
                      SpaceInfo space,
                      AllocatedType type,
                      int size,
                      boolean isArray,
                      int arrayLength,
                      AllocationSite allocationSite,
                      long[] pointedFrom,
                      long[] pointsTo,
                      EventType eventType,
                      List<RootPtr> rootPtrs) {
        classify(address,
                 objectInfo,
                 space,
                 type,
                 size,
                 isArray,
                 arrayLength,
                 allocationSite,
                 pointedFrom,
                 pointsTo,
                 eventType,
                 rootPtrs,
                 classifier,
                 conditionalClassifier);
    }
}