package at.jku.mevss.anttracks.heap.roots;

import at.jku.mevss.anttracks.heap.DetailedHeap;

import java.nio.ByteBuffer;

public class OtherRoot extends RootPtr {

    private final RootType rootType;

    public OtherRoot(long addr, RootType rootType) {
        super(addr);
        this.rootType = rootType;
    }

    public String toString() {
        return rootType.stringRep;
    }

    @Override
    public String toShortString() {
        return rootType.stringRep;
    }

    @Override
    public byte[] getMetadata() {
        return ByteBuffer.allocate(1 + Long.BYTES).put(rootType.byteVal).putLong(addr).array();
    }

    @Override
    public RootType getRootType() {
        return rootType;
    }

    @Override
    public void resolve(DetailedHeap heap) throws Exception {
        resolved = true;
    }

    @Override
    public String[] hierarchy() {
        String[] ret = {"Root: " + toString()};
        return ret;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }

        if (!OtherRoot.class.isAssignableFrom(obj.getClass())) {
            return false;
        }

        final OtherRoot other = (OtherRoot) obj;

        return this.addr == other.addr;
    }

    @Override
    public String getTypeString() {
        return rootType.stringRep;
    }

}
