package at.jku.mevss.anttracks.parser;

import at.jku.mevss.anttracks.heap.GarbageCollectionCause;
import at.jku.mevss.anttracks.heap.GarbageCollectionType;

public class ParserGCInfo {
    public final GarbageCollectionType type;
    public final GarbageCollectionCause cause;
    public final int id;
    public final long time;
    public final boolean concurrent;

    public ParserGCInfo(GarbageCollectionType type, GarbageCollectionCause cause, int id, long time) {
        this(type, cause, id, time, false);
    }

    public ParserGCInfo(GarbageCollectionType type, GarbageCollectionCause cause, int id, long time, boolean concurrent) {
        this.type = type;
        this.cause = cause;
        this.id = id;
        this.time = time;
        this.concurrent = concurrent;
    }

    @Override
    public String toString() {
        return String.format("GC #%d @ %d, %s (%s)", id, time, type, cause);
    }
}