package at.jku.mevss.anttracks.util;

import at.jku.mevss.anttracks.heap.IndexBasedHeap;

import java.util.BitSet;

public class ClosureUtil {
    public static int getClosureByteCount(BitSet closure, IndexBasedHeap heap) {
        if (heap != null && closure != null) {
            int closureBytes = 0;
            for (int idx = closure.nextSetBit(0); idx != -1; idx = closure.nextSetBit(idx + 1)) {
                closureBytes += heap.getSize(idx);
            }
            return closureBytes;
        } else {
            return -1;
        }
    }
}
