/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.util;

public interface Consts {

    public static final int ARRAY_SIZE_MAX_SMALL = 255;
    public static final int ABSOLUTE_PTR = 255;
    public static final int START_ARRAY_LEN = 64;
    public static final int UNDEFINED_ADDR = -1;
    public static final int UNDEFINED_LENGTH = -1;

    public static final int AVERAGE_OBJECT_SIZE = 25;

    public static final int ANCHOR_MASK = 0xFFFF00FF;
    public static final int HEX_WORD = 0xFF000000;
    public static final int HEX_ELEM_SIZE = 0x00FF;
    public static final int HEX_SHORT = 0xFFFF;
    public static final int HEX_BYTE = 0xFF;

    public static int AVAILABLE_PROCESSORS() { return Runtime.getRuntime().availableProcessors(); }

    public static final int HEAP_FILES_MAGIC_PREFIX = 0xABCDEF42;
    public static final String ANT_META_DIRECTORY = ".ant_tracks_trace_meta_data";
    public static final String HEADERS_META_FILE = "header";
    public static final String HEAP_INDEX_META_FILE = "index";
    public static final String STATISTICS_META_FILE = "statistics";
    public static final String FEATURES_META_FILE = "features";
    public static final String LIST_TREE_EXTENSION = ".listtree";
    public static final String DIFF_STAT_EXTENSION = ".diffstat";
    public static final String DIFF_INTERVAL_EXTENSION = ".diffinterval";
    public static final String DIFF_HEAP_EXTENSION = ".diffheap";
}
