/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.util;

public class LimitingIterator<T> extends AbstractIterator<T> {

    private final AbstractIterator<T> iterator;
    private final int max;
    private int n;

    public LimitingIterator(AbstractIterator<T> iterator, int max) {
        this.iterator = iterator;
        this.max = max;
    }

    @Override
    public boolean hasNext() {
        return n < max && iterator.hasNext();
    }

    @Override
    public T next() {
        return n++ < max ? iterator.next() : null;
    }

}
