/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.util;

public class MutableLong implements Comparable<MutableLong> {

    private long val;

    public MutableLong() {
        this(0);
    }

    public MutableLong(int value) {
        this((long) value);
    }

    public MutableLong(long value) {
        this.val = value;
    }

    public long get() {
        return val;
    }

    public void set(long value) {
        this.val = value;
    }

    public void inc() {
        val++;
    }

    public void dec() {
        val--;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (val ^ (val >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        MutableLong other = (MutableLong) obj;
        if (val != other.val) {
            return false;
        }
        return true;
    }

    public int compareTo(MutableLong other) {
        return val < other.val ? -1 : (val == other.val ? 0 : 1);
    }

    public String toString() {
        return String.valueOf(val);
    }

    public void add(long i) {
        val += i;
    }
}
