/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.util;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class StreamUtil {

    public static long copy(InputStream in, OutputStream out) throws IOException {
        long size = 0;
        byte[] buffer = new byte[1024 * 8];
        for (int nRead = in.read(buffer); nRead > 0; nRead = in.read(buffer)) {
            out.write(buffer, 0, nRead);
            size += nRead;
        }
        return size;
    }

    private StreamUtil() {
        throw new Error("Do not instantiate!");
    }

}
