/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.scala.trace.parser.playground

object Playground extends App {
    val x = new TestJavaClass()

    /*
    val calendar = Calendar.getInstance();
    calendar.set(Calendar.HOUR_OF_DAY, 20);
    calendar.set(Calendar.MINUTE, 0);
    calendar.set(Calendar.SECOND, 0);

    while (calendar.getTimeInMillis() < Calendar.getInstance().getTimeInMillis() || calendar.get(Calendar.DAY_OF_MONTH) != 19) {
      calendar.add(Calendar.DAY_OF_MONTH, 1);
    }
    while (calendar.getTimeInMillis() < Calendar.getInstance().getTimeInMillis() || calendar.get(Calendar.DAY_OF_WEEK) != 2) {
      calendar.add(Calendar.DAY_OF_WEEK, 1);
    }

    val fmt = new SimpleDateFormat("dd-MMM-yyyy HH-mm-ss");
    fmt.setCalendar(calendar);
    val dateFormatted = fmt.format(calendar.getTime());
    println(dateFormatted);

    */

    val firstObjectInfos: (Int, TestObjectInfo) = 600 -> new TestObjectInfo(EventType.OBJ_ALLOC_SLOW, 1, 1, 8, 8)
    val secondObjectInfos: (Int, TestObjectInfo) = 700 -> new TestObjectInfo(EventType.OBJ_ALLOC_FAST_C2, 2, 2, 16, 8)
    val thirdObjectInfos: (Int, TestObjectInfo) = 1000 -> new TestObjectInfo(EventType.OBJ_ALLOC_FAST_C2, 3, 2, 16, 8)

    def typeIdToName(id: Int): String = {
        id match {
            case 1 => "String"
            case 2 => "Buffer"
        }
    }

    val typeClassifier = new SingleClassification[String] {
        override val name: String = "Type Name"

        override def classify(address: Long, space: SpaceInfo, objType: AllocatedType, size: Integer, isArray: Boolean, arrayLength: Integer,
                              allocationSite: AllocationSite, pointedFrom: Array[Long], pointsTo: Array[Long], eventType: EventType): String = objType.name
    }

    /*
    def allocSiteIdToAllocStack(id: Int): Seq[String] = {
      id match {
        case 1 => List("allocateString", "main")
        case 2 => List("allocateBuffer", "main")
        case 3 => List("allocateBuffer", "intermediateCall", "main")
      }
    }
    val allocSiteClassifier = new HierarchyClassification[String] {
      val name = "Allocation Site"
      def classify(address: Long, space: SpaceInfo, objType: AllocatedType, size: Integer, isArray: Boolean, arrayLength: Integer,
              allocationSite: AllocationSite, pointedFrom: Array[Long], pointsTo: Array[Long], eventType: EventType) = (allocationSite)
    }
    */

    /*
    def allocSiteIdToFeature(id: Int): Set[String] = {
      id match {
        case 1 => Set("Feature1", "Feature2")
        case 2 => Set("Feature2")
        case 3 => Set("Feature2", "Feature3")
      }
    }
    val featureClassifier = new MultiClassification[String] {
      val name = "Feature classifier"
      def classify(address: Long, space: SpaceInfo, objType: AllocatedType, size: Integer, isArray: Boolean, arrayLength: Integer,
              allocationSite: AllocationSite, pointedFrom: Array[Long], pointsTo: Array[Long], eventType: EventType) = allocSiteIdToFeature(obj allocationSiteId)
    }
    */

    /*
    val conditionalClassifier = new Classifier with Single[Int] with Condition {
      val name = "Age for Feature 1 -> String"
      def condition = List("Base", "Feature1", "String")
      def classify(address: Long, pointsTo: Iterable[Long], obj: ObjectInfo) = rng.nextInt(10)

      val rng = new Random()
    }
    */

    val classifiers = //Seq(featureClassifier, typeClassifier, allocSiteClassifier)
        Seq(typeClassifier)
    val g = Grouping()
    for (i <- 1 to 10000) {
        if (i <= firstObjectInfos._1)
            g(i, new SpaceInfo("example"), null, firstObjectInfos._2.size, false, 0, null, null, null, null, classifiers)
        else if (i <= secondObjectInfos._1)
            g(i, new SpaceInfo("example"), null, secondObjectInfos._2.size, false, 0, null, null, null, null, classifiers)
        else if (i <= thirdObjectInfos._1)
            g(i, new SpaceInfo("example"), null, thirdObjectInfos._2.size, false, 0, null, null, null, null, classifiers)
    }

    println(g)
}