/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.chart.fxchart.xy.stackedareapane;

import at.jku.mevss.trace.gui.frame.main.GUI;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import javafx.fxml.FXML;
import javafx.scene.control.CheckBox;
import javafx.scene.control.DialogPane;
import javafx.scene.layout.VBox;

public class FeatureChartConfigurationDialogPane extends DialogPane {

    @FXML
    private VBox vBox;

    private ShowFeature chartPane;

    FeatureChartConfigurationDialogPane() {
        FXMLUtil.load(this, FeatureChartConfigurationDialogPane.class);
    }

    public void init(ShowFeature chartPane) {
        this.chartPane = chartPane;
        for (int i = 0; i < chartPane.getFeatureCount(); i++) {
            final int id = i;
            CheckBox checkbox = new CheckBox(GUI.CLIENT_INFO.getCurrentAppInfo().getSymbols().features.getFeature(id).name);
            checkbox.setSelected(chartPane.getDisplayedFeatures().contains(id));
            checkbox.setOnAction(cae -> chartPane.updateDisplayFeature(checkbox.isSelected(), id));
            vBox.getChildren().add(checkbox);
        }
    }
}
