package at.jku.mevss.trace.gui.chart.jfreechart.xy.stackedarea.base;

import at.jku.mevss.trace.gui.chart.jfreechart.xy.base.XYBaseJFreeChartPane;
import org.jfree.data.xy.AbstractIntervalXYDataset;

public abstract class StackedAreaJFreeChartPane<DATA> extends XYBaseJFreeChartPane<DATA> {

    @Override
    public double getMaxYValue(AbstractIntervalXYDataset dataset) {
        double maxYValue = Double.MIN_VALUE;

        if (dataset.getSeriesCount() > 0) {
            for (int i = 0; i < dataset.getItemCount(0); i++) {
                double y = 0;
                for (int s = 0; s < dataset.getSeriesCount(); s++) {
                    y += dataset.getY(s, i).doubleValue();
                }
                maxYValue = Math.max(maxYValue, y);
            }
        }
        return maxYValue;
    }

    @Override
    public double getMinYValue(AbstractIntervalXYDataset dataset) {
        double minYValue = Double.MAX_VALUE;

        if (dataset.getSeriesCount() > 0) {
            for (int i = 0; i < dataset.getItemCount(0); i++) {
                double y = 0;
                for (int s = 0; s < dataset.getSeriesCount(); s++) {

                    y += dataset.getY(s, i).doubleValue();
                }
                minYValue = Math.min(minYValue, y);
            }
        }
        return minYValue;
    }
}
