/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.classification.classifier.dialog.edit;

import at.jku.mevss.anttracks.classification.ClassifierFactory;
import at.jku.mevss.anttracks.classification.ClassifierFactoryList;
import at.jku.mevss.anttracks.heap.IndexBasedHeap;
import at.jku.mevss.anttracks.heap.symbols.Symbols;
import javafx.scene.control.Dialog;

import java.io.IOException;
import java.util.function.Supplier;

public class EditClassifierDialog extends Dialog<ClassifierFactory> {

    private final EditClassifierDialogPane dialogPane;

    public EditClassifierDialog(Supplier<Symbols> symbolsSupplier,
                                Supplier<IndexBasedHeap> fastHeapSupplier,
                                ClassifierFactory fac,
                                ClassifierFactoryList availableClassifiers)
            throws IOException {
        dialogPane = new EditClassifierDialogPane();
        dialogPane.initialize(fac, availableClassifiers, fastHeapSupplier, symbolsSupplier);
        setDialogPane(dialogPane);

        setResultConverter(result -> {
            if (result == dialogPane.saveButton) {
                // Return new one
                return dialogPane.getClassifier();
            } else if (result == dialogPane.deleteButton) {
                return fac;
            } else if (result.getButtonData().isCancelButton()) {
                return null;
            }
            assert false : result.toString() + " button is not yet supported!";
            return fac;
        });
    }

}
