/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.classification.classifier.dialog.selection;

import at.jku.mevss.anttracks.classification.ClassifierChain;
import at.jku.mevss.trace.gui.model.AvailableClassifierInfo;
import at.jku.mevss.trace.gui.model.SelectedClassifierInfo;
import javafx.scene.control.ButtonType;
import javafx.scene.control.Dialog;

public final class ClassifierSelectionDialog extends Dialog<Boolean> {

    private final ClassifierSelectionDialogPane dialogPane;

    public ClassifierSelectionDialog(AvailableClassifierInfo availableClassifierInfo, SelectedClassifierInfo selectedClassifierInfo) {
        dialogPane = new ClassifierSelectionDialogPane(availableClassifierInfo);
        setDialogPane(dialogPane);
        setResultConverter(result -> {
            return result == ButtonType.APPLY;
        });
        dialogPane.init();
    }

    public ClassifierChain getSelectedClassifiers() {
        return new ClassifierChain(dialogPane.classifierSelectionPane.getSelected());
    }
}
