/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.classification.classifier.dialog.selection;

import at.jku.mevss.trace.gui.classification.classifier.component.selectionpane.ObjectClassifierSelectionPane;
import at.jku.mevss.trace.gui.model.AvailableClassifierInfo;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.ButtonType;
import javafx.scene.control.DialogPane;

public class ClassifierSelectionDialogPane extends DialogPane {

    final ObjectClassifierSelectionPane classifierSelectionPane;

    ClassifierSelectionDialogPane(AvailableClassifierInfo availableClassifierInfo) {
        classifierSelectionPane = new ObjectClassifierSelectionPane();
        classifierSelectionPane.init(availableClassifierInfo, 0, false);
        classifierSelectionPane.switchToConfigurationPerspective();
        classifierSelectionPane.setCollapsible(false);

        FXMLUtil.load(this, ClassifierSelectionDialogPane.class);
    }

    public void init() {
        setContent(classifierSelectionPane);
        getApplyButton().setDisable(true);
    }

    private Button getApplyButton() {
        Node node = lookupButton(ButtonType.APPLY);
        if (node instanceof Button) {
            return (Button) node;
        } else {
            throw new IllegalStateException("Apply Button not found - Dialog may not be initialized correctly");
        }
    }

}
