/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.classification.filter;

import at.jku.mevss.anttracks.classification.ClassifierException;
import at.jku.mevss.anttracks.classification.Filter;
import at.jku.mevss.anttracks.classification.enumerations.ClassifierSourceCollection;

@at.jku.mevss.anttracks.classification.annotations.Filter(name = "Exclude objects without pointers", desc = "This filter filters every object that has no pointer / " +
        "reference " +
        "field", collection = ClassifierSourceCollection.ALL)
public class NoPointersFilter extends Filter {

    @Override
    public Boolean classify() {
        try {
            int[] pointsTo = pointsToIndices();
            return pointsTo != null && pointsTo.length > 0;
        } catch (ClassifierException ex) {
            try {
                long[] pointsTo = pointsTo();
                return pointsTo != null && pointsTo.length > 0;
            } catch (ClassifierException e) {
                e.printStackTrace();
                return false;
            }
        }
    }
}
