/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.component.general;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.util.List;

public class DropdownPanel<T> extends JPanel {

    private static final long serialVersionUID = -5988937161286854337L;

    private final static int labelWidth = 140;
    private final static int textWidth = 400;

    private final JLabel label;
    private JComboBox<String> dropdown = new JComboBox<>();
    private final List<T> data;

    public DropdownPanel(String labelText, List<T> data, ActionListener action) {
        super(new FlowLayout(FlowLayout.LEFT));
        this.data = data;
        label = new JLabel(labelText);
        label.setPreferredSize(new Dimension(labelWidth, 25));
        add(label);
        dropdown = new JComboBox<>();
        dropdown.setPreferredSize(new Dimension(textWidth, 25));
        dropdown.addActionListener(action);
        this.data.forEach(d -> {
            dropdown.addItem(d.toString());
        });
        add(dropdown);
    }

    public T getSelection() {
        return dropdown.getSelectedIndex() < 0 ? null : data.get(dropdown.getSelectedIndex());
    }
}
