/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.component.treetable;

import javax.swing.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.function.Consumer;
import java.util.function.Supplier;

public class TreeContextMenuItem extends JMenuItem {

    private static final long serialVersionUID = -4187164408336680439L;

    private final Supplier<String> textSupplier;
    private final Consumer<MouseEvent> onClick;

    public TreeContextMenuItem(Supplier<String> textSupplier, Consumer<MouseEvent> onClick) {
        super(textSupplier.get());
        this.textSupplier = textSupplier;
        this.onClick = onClick;

        addMouseListener(new MouseAdapter() {
            @Override
            public void mouseReleased(MouseEvent e) {
                TreeContextMenuItem.this.onClick.accept(e);
            }
        });
    }

    public void updateText() {
        setText(textSupplier.get());
    }
}
