package at.jku.mevss.trace.gui.frame.main.tab.heapdiffing.model;

import at.jku.mevss.trace.gui.chart.base.ApplicationChartFactory;
import at.jku.mevss.trace.gui.frame.main.tab.heapdiffing.component.heapstatisticstreetableview.DiffingTreeTableView;

public class PlotableDiffingData {
    public enum PlotStyle {
        PermDiedBorn,
        Temp
    }

    public double before;
    public double perm;
    public double died;
    public double born;
    public double temp;
    public double after;
    public double maxDied;
    public double maxAfter;
    public double maxTemp;
    public final PlotStyle plotStyle;

    public PlotableDiffingData(DiffingData data, DiffingTreeTableView.DiffingPlotInfo info, ApplicationChartFactory.MemoryConsumptionUnit memoryType, PlotStyle style) {
        switch (memoryType) {
            case OBJECTS:
                before = data.before.objects;
                perm = data.perm.objects;
                died = data.died.objects;
                born = data.born.objects;
                temp = data.temp.objects;
                after = data.after.objects;
                maxDied = info.maxDiedObjects;
                maxAfter = info.maxAfterObjects;
                maxTemp = info.maxTempObjects;
                break;
            case BYTES:
                before = data.before.bytes;
                perm = data.perm.bytes;
                died = data.died.bytes;
                born = data.born.bytes;
                temp = data.temp.bytes;
                after = data.after.bytes;
                maxDied = info.maxDiedBytes;
                maxAfter = info.maxAfterBytes;
                maxTemp = info.maxTempBytes;
                break;
        }
        this.plotStyle = style;
    }
}
