package at.jku.mevss.trace.gui.frame.main.tab.heapvisualization;

import at.jku.mevss.anttracks.classification.ClassifierChain;
import at.jku.mevss.anttracks.classification.ConditionalClassifierList;
import at.jku.mevss.anttracks.heap.DetailedHeap;
import at.jku.mevss.trace.gui.model.AppInfo;
import at.jku.mevss.trace.gui.model.DetailedHeapInfo;
import at.jku.mevss.trace.gui.model.HeapVisualizationStatisticsInfo;
import at.jku.mevss.trace.gui.task.DetailedHeapTask;
import javafx.application.Platform;
import javafx.event.Event;
import javafx.event.EventHandler;

import java.util.ArrayList;

import static at.jku.mevss.trace.gui.frame.main.GUI.CLIENT_INFO;

public class HeapVisualizationTask extends DetailedHeapTask {
    private final HeapVisualizationStatisticsInfo statisticsInfo;
    private final HeapVisualizationTab heapVisualizationTab;

    public HeapVisualizationTask(AppInfo appInfo, long time) {
        super(appInfo, time);
        statisticsInfo = new HeapVisualizationStatisticsInfo(new DetailedHeapInfo(appInfo, time),
                                                             new ClassifierChain(),
                                                             new ConditionalClassifierList(),
                                                             new ArrayList<>());
        this.heapVisualizationTab = new HeapVisualizationTab();
        CLIENT_INFO.getMainFrame().addTab(heapVisualizationTab);
    }

    @Override
    protected void handleTaskCancelled() {
        // close tab
        Platform.runLater(() -> {
            EventHandler<Event> handler = heapVisualizationTab.getOnClosed();
            if (handler != null) {
                handler.handle(null);
            }

            heapVisualizationTab.getTabPane().getTabs().remove(heapVisualizationTab);
        });
    }

    @Override
    protected void additionalBackgroundWork(DetailedHeap heap) {

    }

    @Override
    protected void suceeded() {
        this.statisticsInfo.getDetailsInfo().setHeap(getValue());
        this.heapVisualizationTab.init(statisticsInfo);
    }
}
