/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.frame.main.tab.heapvisualization.component;

import at.jku.mevss.trace.gui.frame.main.tab.heapvisualization.HeapVisualizationTab;
import at.jku.mevss.trace.gui.frame.main.tab.heapvisualization.model.ClassificationColorTableModel;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import at.jku.mevss.trace.gui.utils.WindowUtil;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.layout.HBox;

import javax.swing.*;
import javax.swing.table.TableModel;
import java.awt.*;

public class HeapVisualizationOperationPane extends HBox {

    // Buttons
    @FXML
    private Button collapseButton;
    @FXML
    private Button exportButton;
    @FXML
    private Button selectColorsButton;

    public HeapVisualizationOperationPane() {
        FXMLUtil.load(this, HeapVisualizationOperationPane.class);
    }

    public void init(HeapVisualizationTab tab) {
        collapseButton.setOnAction(ae -> tab.minimizeConfigView());
        selectColorsButton.setOnAction(ae -> {
            JDialog colorPicker = new JDialog((Frame) null, "Select Colors");

            TableModel tableModel = new ClassificationColorTableModel(tab.getModel().getCurrentPixelMap().getData(), tab);
            JTable table = new JTable(tableModel);
            table.setDefaultRenderer(Color.class, new ColorRenderer());
            table.setDefaultEditor(Color.class, new ColorEditor());
            table.setAutoCreateRowSorter(true);
            JScrollPane scrollPane = new JScrollPane(table);
            colorPicker.add(scrollPane);
            colorPicker.setModal(true);
            colorPicker.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
            colorPicker.setSize(500, 500);
            colorPicker.pack();
            WindowUtil.centerOnDefaultScreen(colorPicker);
            colorPicker.setVisible(true);
        });
        exportButton.setOnAction(ae -> {
            PNGExport.showDialog(tab.getModel().getCurrentPixelMap(), tab);
        });
    }

}
