/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 *
 */
package at.jku.mevss.trace.gui.frame.main.tab.heapvisualization.model;

/**
 * @author Christina Rammerstorfer
 */
public class ZoomStateData {

    public static final long LAST_PIXEL = -2;

    public final long clusterSize;
    public final int pixelSize;
    public final long startIndex, endIndex;
    private int selectionStartX, selectionStartY, selectionEndX, selectionEndY;

    public ZoomStateData(long clusterSize, int pixelSize, long startIndex, long endIndex) {
        this.clusterSize = clusterSize;
        this.pixelSize = pixelSize;
        this.startIndex = startIndex;
        this.endIndex = endIndex;
        setSelectedArea(-1, -1, -1, -1);
    }

    public void setSelectedArea(int startX, int startY, int endX, int endY) {
        selectionStartX = startX;
        selectionStartY = startY;
        selectionEndX = endX;
        selectionEndY = endY;
    }

    public int[] getSelectedArea() {
        return new int[]{selectionStartX, selectionStartY, selectionEndX, selectionEndY};
    }

    public boolean hasSelectedArea() {
        return selectionStartX > -1 && selectionStartY > -1 && selectionEndX > -1 && selectionEndY > -1;
    }

}
