package at.jku.mevss.trace.gui.frame.main.tab.lifetimevisualization.visualization;

import at.jku.mevss.anttracks.classification.ClassifierChain;
import at.jku.mevss.anttracks.classification.Filter;
import at.jku.mevss.trace.gui.chart.base.ApplicationChartFactory;
import at.jku.mevss.trace.gui.frame.main.tab.lifetimevisualization.LifetimeVisualizationInfo;
import at.jku.mevss.trace.gui.frame.main.tab.lifetimevisualization.SeriesSort;

import java.util.List;

public class LifetimeVisualizationDiagramInfo {
    private LifetimeVisualizationInfo lifetimeVisualizationInfo;
    private boolean useLineChart;
    private int seriesCount;
    private SeriesSort seriesSort;
    private DiagramMetric diagramMetric;
    //this List is used to save to selection of the user when he opens a new detail diagram by clicking on one of the series
    private List<String> selectedKeys;
    private ClassifierChain classifierChain;
    private Filter[] filters;
    private boolean showOtherSeries;

    public LifetimeVisualizationDiagramInfo(LifetimeVisualizationInfo lifetimeVisualizationInfo,
                                            boolean useLineChart,
                                            int seriesCount,
                                            SeriesSort seriesSort,
                                            DiagramMetric diagramMetric,
                                            List<String> selectedKeys,
                                            ClassifierChain classifierChain, Filter[] filters, boolean showOtherSeries) {
        this.lifetimeVisualizationInfo = lifetimeVisualizationInfo;
        this.useLineChart = useLineChart;
        this.seriesCount = seriesCount;
        this.seriesSort = seriesSort;
        this.diagramMetric = diagramMetric;
        this.selectedKeys = selectedKeys;
        this.classifierChain = classifierChain;
        this.filters = filters;
        this.showOtherSeries = showOtherSeries;
    }

    public boolean isShowOtherSeries() {
        return showOtherSeries;
    }

    public void setShowOtherSeries(boolean showOtherSeries) {
        this.showOtherSeries = showOtherSeries;
    }

    public List<String> getSelectedKeys() {
        return selectedKeys;
    }

    public String[] getSelectedKeysAsArray() {
        return selectedKeys.toArray(new String[0]);
    }

    public void setSelectedKeys(List<String> selectedKeys) {
        this.selectedKeys = selectedKeys;
    }

    public ClassifierChain getClassifierChain() {
        return classifierChain;
    }

    public void setClassifierChain(ClassifierChain classifierChain) {
        this.classifierChain = classifierChain;
    }

    public Filter[] getFilters() {
        return filters;
    }

    public void setFilters(Filter[] filters) {
        this.filters = filters;
    }

    public LifetimeVisualizationInfo getLifetimeVisualizationInfo() {
        return lifetimeVisualizationInfo;
    }

    public void setLifetimeVisualizationInfo(LifetimeVisualizationInfo lifetimeVisualizationInfo) {
        this.lifetimeVisualizationInfo = lifetimeVisualizationInfo;
    }

    public int getSeriesCount() {
        return seriesCount;
    }

    public void setSeriesCount(int seriesCount) {
        this.seriesCount = seriesCount;
    }

    public SeriesSort getSeriesSort() {
        return seriesSort;
    }

    public void setSeriesSort(SeriesSort seriesSort) {
        this.seriesSort = seriesSort;
    }

    public boolean isUseLineChart() {
        return useLineChart;
    }

    public void setUseLineChart(boolean useLineChart) {
        this.useLineChart = useLineChart;
    }

    public DiagramMetric getDiagramMetric() {
        return diagramMetric;
    }

    public void setDiagramMetric(DiagramMetric diagramMetric) {
        this.diagramMetric = diagramMetric;
    }
}
