/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.frame.main.tab.timelapse.components;

import at.jku.mevss.trace.gui.frame.main.tab.timelapse.model.TimelapseModel;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;

/**
 * @author Christina Rammerstorfer
 */
public class TimelapsePane extends JComponent {
    private static final long serialVersionUID = 5782861094854964575L;
    private static final int MIN_WIDTH = 1000;
    private static final int MIN_HEIGHT = 100;
    private TimelapseModel model;

    public void setModel(TimelapseModel model) {
        this.model = model;
    }

    @Override
    public void paint(Graphics g) {
        if (model == null) {
            return;
        }
        BufferedImage image = model.getCurrentImage();
        java.awt.Rectangle r = g.getClipBounds();
        int width = image.getWidth();
        int height = image.getHeight();
        BufferedImage imageClip = image.getSubimage(r.x, r.y, Math.min(r.width, width), r.height > height ? height - 1 : Math.min(r.height, height - r.y - 1));
        g.drawImage(imageClip, r.x, r.y, null);
    }

    @Override
    public Dimension getPreferredSize() {
        if (model == null) {
            return new Dimension(MIN_WIDTH, MIN_HEIGHT);
        }
        return new Dimension(model.getCurrentImage().getWidth(), model.getCurrentImage().getHeight());
    }

}
