/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.model;

import java.text.DecimalFormat;

public class ApproximateDouble implements Comparable<ApproximateDouble> {

    public static final ApproximateDouble ZERO = new ApproximateDouble(0, true);
    public static final ApproximateDouble APPROXIMATE_ZERO = new ApproximateDouble(0, false);

    public final double value;
    public final boolean isExact;

    public ApproximateDouble(double value, boolean exact) {
        this.value = value;
        isExact = exact;
    }

    @Override
    public int compareTo(ApproximateDouble o) {
        return Double.compare(value, o.value);
    }

    @Override
    public String toString() {
        // cast this to a long, otherwise the alignment is off in tables, and we can neglect a single object/byte off
        return (isExact ? "" : "~ ") + new DecimalFormat("###,###.#").format((long) value);
    }
}
