/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.model;

import java.util.Arrays;

public class Types implements Comparable<Types> {

    public final String[] types;

    public Types(String... types) {
        if (types == null) {
            throw new NullPointerException();
        }
        types = types.clone();
        Arrays.sort(types);
        this.types = types;
    }

    @Override
    public int compareTo(Types that) {
        for (int i = 0; i < Math.min(this.types.length, that.types.length); i++) {
            int diff = this.types[i].compareTo(that.types[i]);
            if (diff != 0) {
                return diff;
            }
        }
        return that.types.length - this.types.length;
    }

    @Override
    public String toString() {
        return Arrays.toString(types);
    }
}
