/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.model;

import java.math.BigDecimal;

public class ValueWithReference implements Comparable<ValueWithReference> {

    public double value;
    public double reference;
    public Percentage percentage;

    public ValueWithReference(double value, double reference) {
        this.value = value;
        this.reference = reference;
        percentage = reference == 0 ? new Percentage(0) : new Percentage(new BigDecimal(value / reference * 100).setScale(1, BigDecimal.ROUND_HALF_UP).doubleValue());
    }

    @Override
    public int compareTo(ValueWithReference that) {
        return (int) Math.signum(value - that.value);
    }

    @Override
    public String toString() {
        return String.valueOf(value);
    }
}
