/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.model.tablecellrenderer;

import at.jku.mevss.trace.gui.model.ApproximateDouble;

import javax.swing.*;
import javax.swing.table.DefaultTableCellRenderer;
import java.awt.*;

public class ApproximateDoubleCellRenderer extends DefaultTableCellRenderer {

    private static final long serialVersionUID = -7629559964336560836L;
    private final boolean toKb;

    public ApproximateDoubleCellRenderer(boolean toKb) {
        this.toKb = toKb;
    }

    public ApproximateDoubleCellRenderer() {
        this(false);
    }

    @Override
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
        super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);

        if (value != null) {
            ApproximateDouble num = (ApproximateDouble) value;
            if (toKb) {
                num = new ApproximateDouble(num.value / 1024, num.isExact);
            }

            setHorizontalAlignment(SwingConstants.RIGHT);
            setText(num.toString());
        }
        return this;
    }
}
