/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.model.tablecellrenderer;

import at.jku.mevss.trace.gui.model.ValueWithReference;

import java.text.DecimalFormat;

public class ValueWithReferenceCellRenderer extends BarCellRenderer {
    private static final long serialVersionUID = 2805711811767537371L;

    private static final DecimalFormat format = new DecimalFormat("###,###.#");

    @Override
    String defineTextToShow(Object value) {
        return format.format(((ValueWithReference) value).value);
    }

    @Override
    double defineFillRatio(Object value) {
        return ((ValueWithReference) value).percentage.value / 100.0;
    }
}
